Index: branches/reconfiguration/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h
===================================================================
--- branches/reconfiguration/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 904)
+++ branches/reconfiguration/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 926)
@@ -96,5 +96,5 @@
     VciSignals<vci_param_int>             signal_int_vci_tgt_xicu;
     VciSignals<vci_param_int>             signal_int_vci_tgt_mdma;
-    VciSignals<vci_param_int>             signal_int_vci_tgt_brom;
+    VciSignals<vci_param_int>             signal_int_vci_tgt_drom;
     VciSignals<vci_param_int>             signal_int_vci_tgt_iobx;
 
@@ -149,5 +149,5 @@
     VciMultiDma<vci_param_int>*                       mdma;
 
-    VciSimpleRom<vci_param_int>*                      brom;
+    VciSimpleRom<vci_param_int>*                      drom;
 
     VciLocalCrossbar<vci_param_int>*                  int_xbar_d;
@@ -212,5 +212,5 @@
                     size_t                             int_xicu_tgt_id,
                     size_t                             int_mdma_tgt_id,
-                    size_t                             int_brom_tgt_id,
+                    size_t                             int_drom_tgt_id,
                     size_t                             int_iobx_tgt_id,
                     size_t                             int_proc_ini_id,
Index: branches/reconfiguration/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp
===================================================================
--- branches/reconfiguration/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 904)
+++ branches/reconfiguration/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 926)
@@ -51,5 +51,5 @@
         size_t                             int_xicu_tgt_id, // local index
         size_t                             int_mdma_tgt_id, // local index
-        size_t                             int_brom_tgt_id, // local index
+        size_t                             int_drom_tgt_id, // local index
         size_t                             int_iobx_tgt_id, // local index
 
@@ -210,10 +210,10 @@
                      nb_dmas);                            // number of IRQs
 
-    ///////////   DISTRIBUTED BOOT ROM
-    std::ostringstream s_brom;
-    s_brom << "brom_" << x_id << "_" << y_id;
-    brom = new VciSimpleRom<vci_param_int>(
-                     s_brom.str().c_str(),
-                     IntTab(cluster_id, int_brom_tgt_id),
+    ///////////   DISTRIBUTED ROM
+    std::ostringstream s_drom;
+    s_drom << "drom_" << x_id << "_" << y_id;
+    drom = new VciSimpleRom<vci_param_int>(
+                     s_drom.str().c_str(),
+                     IntTab(cluster_id, int_drom_tgt_id),
                      mt_int,
                      loader,
@@ -473,5 +473,5 @@
     int_xbar_d->p_to_target[int_xicu_tgt_id]          (signal_int_vci_tgt_xicu);
     int_xbar_d->p_to_target[int_mdma_tgt_id]          (signal_int_vci_tgt_mdma);
-    int_xbar_d->p_to_target[int_brom_tgt_id]          (signal_int_vci_tgt_brom);
+    int_xbar_d->p_to_target[int_drom_tgt_id]          (signal_int_vci_tgt_drom);
     int_xbar_d->p_to_initiator[int_mdma_ini_id]       (signal_int_vci_ini_mdma);
     for (size_t p = 0; p < nb_procs; p++)
@@ -597,8 +597,8 @@
         mdma->p_irq[i]                           (signal_irq_mdma[i]);
 
-    /////////////////////////////////// BROM
-    brom->p_clk                                  (this->p_clk);
-    brom->p_resetn                               (this->p_resetn);
-    brom->p_vci                                  (signal_int_vci_tgt_brom);
+    /////////////////////////////////// DROM
+    drom->p_clk                                  (this->p_clk);
+    drom->p_resetn                               (this->p_resetn);
+    drom->p_vci                                  (signal_int_vci_tgt_drom);
 
     //////////////////////////// RAM network CMD & RSP routers